/**********************************************************************
 i2cdrv.c
 
 I2C Bus Driver
 
 ST7032i LCD controler driver

 2009/05/23 1.00 Sugawara be-con

 **********************************************************************/


#include "sfr_r829.h"
#include <string.h>
#include "std_type.h"
#include "i2cdrv.h"


/*==============================================================*
	萔A}N`
 *==============================================================*/

#ifndef _DEBUG_
//#define		PutSio( x, y )	PutcSCI( y )
//#define		DebOutStr(x)	message(x)
#define		PutSio( x, y )
#define		DebOutStr(x)
#endif



//I2C֌W|[gݒ@|[eBOςΑ̃VXełOKȂ͂B(Ƃ̓^C~O)
#define	IIC_SNDMODE	(pd3_3 = 1)
#define	IIC_RCVMODE	(pd3_3 = 0)
#define	SCDA	  (p3_3 )
#define	SCDA_LO	  (p3_3 = 0)
#define	SCDA_HI	  (p3_3 = 1)

#define	SCL_OUT	(pd3_4 = 1)

#define	SCLK_LO	  (p3_4 = 0)
#define	SCLK_HI	  (p3_4 = 1)




#define		I2C_LCD_ADD_WR	0b01111100	// LCD
#define		LCD_CMD_RS1_CO	0b11000000	// RSBIT = 1 f[^
#define		LCD_CMD_RS1		0b01000000	// RSBIT = 1 Ȃf[^
#define		LCD_CMD_RS0_CO	0b10000000	// RSBIT = 1 R}h
#define		LCD_CMD_RS0		0b00000000	// RSBIT = 1 ȂR}h


#define		SDA_LO		{SCDA_LO;IIC_SNDMODE;}
#define		SDA_HI		IIC_RCVMODE
#define		ACK1		SCDA
#define		SDA1		SCDA

#define		SCL1_PULSE	{	/*SCLK_LO;*/SCLK_HI;SCLK_HI;SCLK_LO;} //SCLK_HISCLK_LOŃpX𒲐߂ĂB

#define		ACK1_PULSE	{	SCDA_LO;IIC_SNDMODE;SCLK_HI;SCLK_LO;}

#define		NACK1_PULSE	{	SDA_HI;SCLK_HI;SCLK_LO;}

#define		STOP1_CONDITION	{	SCDA_LO;IIC_SNDMODE;SCLK_HI;SCLK_HI;SDA_HI;}//SCLK_HIAI2C^C~O



/*==============================================================*
@֐vg^Cv錾
 *==============================================================*/
void	I2C_init( void );

BOOL	I2C_lcd_cmd(  unsigned char cmd  );
BOOL	I2C_lcd_data(  unsigned char data  );
BOOL	I2C_lcd_nputs(  unsigned char *data ,short n );

static	BOOL	i2c_wrt_device( unsigned char dv );
static	BOOL	i2c_wrt_sub( unsigned char d );
static	BOOL	i2c_wrt_data( unsigned char data );
static	unsigned char	i2c_read_data( void );
static	BOOL	check_ack( void );


/**********************************************************************
 LCDɑ΂ăR}h𑗐M

 
 unsigned char cmd :MR}h
 
 ߂l@BOOL
   TRUE@
   FALSE@s
 
 **********************************************************************/
BOOL	I2C_lcd_cmd(  unsigned char cmd  )
{
	unsigned char	i,t;
	unsigned short	wt;
	BOOL b;
	
	b = i2c_wrt_device( I2C_LCD_ADD_WR );		// ޯ,޲ID,ޏo

	if(b==TRUE)	b = i2c_wrt_data( LCD_CMD_RS0 );	// ڽ
	if(b==TRUE) b =  i2c_wrt_data( cmd );		// ް
	STOP1_CONDITION;		// įޯďo
	
	return b;
}

/**********************************************************************
 LCDɑ΂ăf[^𑗐M

 
 unsigned char data :Mf[^
 
 ߂l@BOOL
   TRUE@
   FALSE@s
 
 **********************************************************************/

BOOL	I2C_lcd_data(  unsigned char data  )
{
	unsigned char	i,t;
	unsigned short	wt;
	BOOL b;
	
	b = i2c_wrt_device( I2C_LCD_ADD_WR );		// ޯ,޲ID,ޏo

	if(b==TRUE)	b = i2c_wrt_data( LCD_CMD_RS1 );	// ڽ
	if(b==TRUE) b =  i2c_wrt_data( data );		// ް
	STOP1_CONDITION;		// įޯďo
	
	return b;
}

/**********************************************************************
 LCDɑ΂n̕𑗐M

 
 unsigned char *data:M
 short n :
 
߂l@BOOL
  TRUE@
  FALSE@s

 **********************************************************************/
BOOL	I2C_lcd_nputs(  unsigned char *data ,short n )
{
	unsigned char	i,t;
	unsigned short	wt;
	BOOL b;
	
	b = i2c_wrt_device( I2C_LCD_ADD_WR );		// ޯ,޲ID,ޏo

	while(n--){
		if(n){
			if(b==TRUE)	b = i2c_wrt_data( LCD_CMD_RS1_CO );	// ڽ
		}else{
			if(b==TRUE)	b = i2c_wrt_data( LCD_CMD_RS1 );	// ڽ
		}
		if(b==TRUE) b =  i2c_wrt_data( *data++ );		// ް
	}
	STOP1_CONDITION;		// įޯďo
	
	return b;
}





/******************************************************************************

 I2C Base
*******************************************************************************/


/**********************************************************************
 I2CoX̏
 
 **********************************************************************/
void	I2C_init( void )
{
	SCL_OUT;
	IIC_RCVMODE;
	SCLK_HI;
}



/**********************************************************************
擪̃foCX
 NAK΂@ACK܂ŃgC

 unsigned char dv: AhX+
 
߂l@BOOL
  TRUE@@(AckL)
  FALSE@s
  
  gĈEEPROM̏ݒȂǂɖɂȂ^CvI2CoXfoCX
  Ή邽߁B
  
 **********************************************************************/
static	BOOL	i2c_wrt_device( unsigned char dv )
{
	unsigned char	i,d;
	unsigned short	t;
	short retrycnt = 0;
	BOOL bret = TRUE;
	int first = 1;
	
	do{
		if(++retrycnt>=100){
			bret = FALSE;
			break;
		}
		if(first){
			first = 0;
		}else{
			STOP1_CONDITION;		// įޯďo
//			tslp_tsk(10);	//	}`^XN̏ꍇɂ
		}
		/* X^[grbg̏o		*/
		SDA_HI;
		SCLK_HI;
		SDA_LO;
		SDA_LO;	//^C~O
		SCLK_LO;
	
		d = dv;	// ڰޱڽw
		for( i=0; i<8; i++ ){				/* 8Bit 	*/
			if( d & 0x80 )	SDA_HI;	/* Data Hi			*/
			else			SDA_LO;	/* Data Lo			*/
			SCL1_PULSE;
			d <<= 1;
		}
	}while(check_ack() == FALSE );
	return bret;
}


/**********************************************************************
8rbgM

 unsigned char d :8bit̑Mf[^

߂l@BOOL
  TRUE@@(AckL)
  FALSE@s

 **********************************************************************/
static	BOOL	i2c_wrt_sub( unsigned char d )
{
	unsigned char	i;
	
	for( i=0; i<8; i++ ){				/* 8Bit 	*/
		if( d & 0x80 )	SDA_HI;	/* Data Hi			*/
		else			SDA_LO;	/* Data Lo			*/
		SCL1_PULSE;
		d <<= 1;
	}
	return check_ack();
}
/**********************************************************************
8rbgM

 unsigned char d :8bit̑Mf[^

߂l@BOOL
  TRUE@@(AckL)
  FALSE@s

 **********************************************************************/

static	BOOL	i2c_wrt_data( unsigned char data )
{
	unsigned char	i,d;
	
	d = data;
	for( i=0; i<8; i++ ){				/* 8Bit 	*/
		if( d & 0x80 )	SDA_HI;		/* Data Hi			*/
		else			SDA_LO;	/* Data Lo			*/
		SCL1_PULSE;
		d <<= 1;
	}
	return check_ack();
}


/**********************************************************************
8rbgM

 void

߂l@unsigned char
	M8Bit̒l

 **********************************************************************/
static	unsigned char	i2c_read_data( void )
{
	unsigned char	i,d;
	unsigned short	t;
	d = 0;
	
	IIC_RCVMODE;
	/* SCL̗Ńf[^o	*/
	for( i=0; i<8; i++ ){				/* 8Bit Ǎ	*/
		d <<= 1;
		if( SDA1 ) d |= BIT0;
		SCLK_HI;
		SCLK_LO;
	}
	return	d;
}


/**********************************************************************
Ack`FbN

 void

߂l@BOOL:
	TRUE:ACKML
	FALSE:ACKM
	
 **********************************************************************/
static	BOOL	check_ack( void )
{
	unsigned short	t;
	BOOL	ret = FALSE;
	
//	SDA_HI;			/* ͊mFׁ̈Ao͑Hi	*/
	IIC_RCVMODE;
	
	SCLK_HI;
	if(!ACK1){
		 ret = TRUE;
	}
	SCLK_LO;
	return	ret;
}






