/**********************************************************************
 LCD ֐
 

 2009/05/23 V1.00  Sugawara be-con

 **********************************************************************/

#include "sfr_r829.h"
#include "std_type.h"
#include "lcdlib.h"
#include "i2cdrv.h"



/*==============================================================*
	萔A}N`A\̐錾
 *==============================================================*/

#define		LINES 		2
#define 	LCD_SIZE	( 16*LINES )
#define 	LINE_SIZE	( LCD_SIZE / LINES )
#define 	UP_LINE		0x80
#define		DWN_LINE	0xc0


//ACR̃AhXƃrbg̊֌W
typedef struct{
	UCHAR adr;
	UCHAR data;
}T_ICON;


/*==============================================================*
@֐vg^Cv錾
 *==============================================================*/



void	LCD_Cursor( UCHAR flg );
void	LCD_Init( void );
void	LCD_Cls( void );
void	LCD_Putchar( char c );
void	LCD_Puts( char *str );
void	LCD_Locate( short x , short y );
void	LCD_Setcgram( short cgno , unsigned char *adr );
void	LCD_Print( short x, short y , char *str );
void 	LCD_nPrint( short x , short y , char *str , short n );


static void lcd_hard_init(void);

static void wait_usec( short n );


/*==============================================================*
@ϐ
 *==============================================================*/



static short	cursorX , cursorY ;
static unsigned char	*cg_adrs[ 8 ] ;			/* CG address				*/

static	const	unsigned char	line_add[] = { UP_LINE , DWN_LINE };
static	char	*const	pLCD_Ver = "v1.00 07.05.23" ;


const static T_ICON icon_arry[7]={
	// ACRAhX, Yrbg
	{0b01000000+0x00, 0b10000},//ICON_ANNTENA
	{0b01000000+0x02, 0b10000},//ICON_PHONE	
	{0b01000000+0x04, 0b10000},//ICON_WLESSND
	{0b01000000+0x06, 0b10000},//ICON_XXXXX	
	{0b01000000+0x09, 0b10000},//ICON_KEYLOCK
	{0b01000000+0x0B, 0b10000},//ICON_SPOFF	
	{0b01000000+0x0F, 0b10000},//ICON_COIN	 
};                

#define	ICON_UD_ADR	(0b01000000+0x07)
#define	ICON_UD_SZ	2
const static UCHAR icon_ud[ICON_UD_SZ]={
	0b10000,	//㉺}[N
	0b01000,
};

#define	ICON_BAT_ADR	(0b01000000+0x0D)

const static UCHAR icon_bat[4]={
	0b01000,//obe[}[N
	0b00100,
	0b00010,
	0b10000,
};



/*----------------------------------------------------------------------*
 *		Tv F LCD Cȕ								*
 *			   F void												*
 *			  l F void												*
 *----------------------------------------------------------------------*/
void	LCD_Init( void )
{
short i ;
	
	for( i=0 ; i<8 ; i++ ) cg_adrs[i] = ( char* )0 ;
	cursorX = cursorY = 0 ;
	lcd_hard_init() ;
}

/*----------------------------------------------------------------------*
 *		Tv F LCD Cu̒d͉					*
 *			   F void												*
 *			  l F void												*
 * LCD_Sleep畜AɂLCD_Inits܂						*
 *----------------------------------------------------------------------*/
void	LCD_Sleep( void )
{
	I2C_lcd_cmd(0b00111001);	//function set
	I2C_lcd_cmd(0b00010100);	//internal osc
	I2C_lcd_cmd(0b01011011);	//Booster OFF
	
	I2C_lcd_cmd(0b01100010);	//follower control OFF
	I2C_lcd_cmd(0b00111000);	//function set

	I2C_lcd_cmd(0b00001000);	//Display OFF

}


/*----------------------------------------------------------------------*
 	Tv F lcd_hard_init n[hEFȀ
 		   F void
 		  l F void
 *----------------------------------------------------------------------*/
void lcd_hard_init(void)
{
	int i;
	I2C_lcd_cmd(0b00111000);	//function set
	
	I2C_lcd_cmd(0b00111001);	//function set
	I2C_lcd_cmd(0b00010100);	//internal osc
	I2C_lcd_cmd(0b01111111);	//contrast1
	I2C_lcd_cmd(0b01011111);	//contrast2
	I2C_lcd_cmd(0b01101010);	//follower control
	for(i=0;i<3000;i++){
		wait_usec(100);
	}
	I2C_lcd_cmd(0b01000000);	// ACR̈̃AhXݒ
	for(i=0;i<0x10;i++){	
		I2C_lcd_data(0); //ACR͍ŏ[NA
	}

	I2C_lcd_cmd(0b00111000);	//functionset
	I2C_lcd_cmd(0b00001100);	//Display ON


	
	I2C_lcd_cmd(0b00000001);	//Clear Display
	wait_usec(200);
}



/*----------------------------------------------------------------------*
 	Tv F 1uSecPʂ̑҂
 		   F short n : ҂ 悻 (R8C20MHz)
 		  l F void
 	n[h[vȂ̂ŁA荞ݏȂǂɂ莞Ԃт܂B
 *----------------------------------------------------------------------*/
static void wait_usec( short n )
{
	short i;
	while(n--){
//		asm("nop");
	}
}








/*----------------------------------------------------------------------*
 *		Tv F J[\ n										*
 *			   F UCHAR flg											*
 *					 LCD_BLINK|LCD_CURSOR@uNJ[\			*
 *					 LCD_BLINK@uN̂							*
 *					 LCD_CURSOR J[\̂							*
 *					 0:BlinkȂ J[\								*
 *			  l F void												*
 *----------------------------------------------------------------------*/
void	LCD_Cursor( UCHAR flg )
{
	UCHAR cmd = 0x0c;
	
	I2C_lcd_cmd(line_add[ cursorY ] + cursorX );
	cmd = 0x0c | (flg & 0x03);
	I2C_lcd_cmd(cmd);
}

/*----------------------------------------------------------------------*
 *		Tv F LCD Display All Clear								*
 *			   F void												*
 *			  l F void												*
 *				Clš͎LCDANZX܂2000uSecxEFCg	*
 *----------------------------------------------------------------------*/
void	LCD_Cls( void )
{
	I2C_lcd_cmd( 0x01 );

	cursorX = cursorY = 0 ;
}

/*----------------------------------------------------------------------*
 *		Tv F kbcɂP\								*
 *			   F c : \										*
 *			  l F void												*
 *----------------------------------------------------------------------*/
void	LCD_Putchar( char c )
{
	I2C_lcd_cmd(line_add[ cursorY ] + cursorX );
	I2C_lcd_data((unsigned char) c) ;

	if( ++cursorX >= LINE_SIZE ){
		cursorX = 0 ;
		if( ++cursorY >= LINES ) cursorY = 0 ;
	}
}

/*----------------------------------------------------------------------*
 *		Tv F kbcɕ\							*
 *			   F *str : \|C^								*
 *			  l F void												*
 *----------------------------------------------------------------------*/
void	LCD_Puts( char *str )
{
	while( *str ) LCD_Putchar( *str++ ) ;
}

/*----------------------------------------------------------------------*
 *		Tv F \ʒuP[g								*
 *			   F x : w ʒu										*
 *			   F y : x ʒu										*
 *			  l F void												*
 *----------------------------------------------------------------------*/
void	LCD_Locate( short x , short y )
{
	if( ( x < LINE_SIZE )&&( y < LINES ) ){
		cursorX = x ;
		cursorY = y ;
	}
}

/*----------------------------------------------------------------------*
 *		Tv F bfɃf[^Zbg						*
 *			   F cgno : bfԍ										*
 *			   F *adr : bfAhX									*
 *			  l F void												*
 *----------------------------------------------------------------------*/
void	LCD_Setcgram( short cgno , unsigned char *adr )
{
short i ;
	if( cg_adrs[ cgno ] == adr ) return ;	/* ꍇ͒~	*/
	cg_adrs[ cgno ] = adr ;
	cgno <<= 3 ;
	cgno |= 0x40 ;
	I2C_lcd_cmd(cgno) ;
	for( i=0 ; i<8 ; i++ ){
		I2C_lcd_data(*adr++) ;	/* CG_data set */
		//wait_lcdready() ;
	}


//	I2C_lcd_nputs(adr,8) ;	/* CG_data set ( auto inc mode ) */

}

/*----------------------------------------------------------------------*
 *		Tv F ẅʒuɕ\							*
 *			   F x	 : 											*
 *			   F y	 : s											*
 *			   F *str : \|C^							*
 *			  l F void												*
 *----------------------------------------------------------------------*/
void	LCD_Print( short x, short y , char *str )
{
	if( ( x < LINE_SIZE )&&( y < LINES ) ){
		cursorX = x ;
		cursorY = y ;
		while( *str ) LCD_Putchar( *str++ ) ;
	}
}

/*----------------------------------------------------------------------*
 *		Tv F ẅʒuɂ̕\					*
 *			   F x	 : 											*
 *			   F y	 : s											*
 *			   F *str : \|C^							*
 *			   F n	 : \									*
 *			  l F void												*
 *----------------------------------------------------------------------*/
void 	LCD_nPrint( short x , short y , char *str , short n )
{
	if( ( x < LINE_SIZE )&&( y < LINES ) ){
		cursorX = x ;
		cursorY = y ;
		while( n-- ) LCD_Putchar( *str++ ) ;
	}
}





/*----------------------------------------------------------------------*
 	Tv F ㉺ACR̕\
 		   F UCHAR icon:\ACR̎w
 				ICON_ANNTENA
 				ICON_PHONE	
 				ICON_WLESSND
 				ICON_XXXXX	
 				ICON_KEYLOCK
 				ICON_SPOFF	
 				ICON_COIN	 
 
 				short flg:0\Ȃ 1:\
  		  l F void
 *----------------------------------------------------------------------*/

void LCD_Icon( short icon,short flg )
{
	I2C_lcd_cmd(0b00111001);	// R}h
	I2C_lcd_cmd(icon_arry[icon].adr);	// ACR̈̃AhXݒ
	if(flg){
		I2C_lcd_data(icon_arry[icon].data);	// ACRf[^
	}else{
		I2C_lcd_data(0x00);	// \܂
	}
	I2C_lcd_cmd(0b00111000);	//
}


/*----------------------------------------------------------------------*
 	Tv F ㉺ACR̕\
 		   F UCHAR iconflg :\ACR̎w
 				0:\Ȃ
 				ICON_UP	:ゾ
 				ICON_DOWN:
 				
 				ICON_UP	|ICON_DOWN :
  		  l F void
 *----------------------------------------------------------------------*/

void LCD_IconUD( UCHAR iconflg )
{
	int i;
	UCHAR dat,flg;
	I2C_lcd_cmd(0b00111001);	// R}h
	I2C_lcd_cmd(ICON_UD_ADR);	// ACR̈̃AhXݒ
	I2C_lcd_data(iconflg);
	I2C_lcd_cmd(0b00111000);	//
}	



/*----------------------------------------------------------------------*
 	Tv F obe[ACR̃x\
 		   F UCHAR level
 				0:\Ȃ
 				1:obe[̗֊ŝ
 				2:cʃx
 				3:cʃx
 				4:cʃx^
  		  l F void
 *----------------------------------------------------------------------*/

#define	ICON_BATCASE		0b00010
#define	ICON_BAT1		0b10000
#define	ICON_BAT2		0b01000
#define	ICON_BAT3		0b00100

void LCD_IconBat( UCHAR level )
{

	UCHAR dat;
	I2C_lcd_cmd(0b00111001);	// R}h
	I2C_lcd_cmd(ICON_BAT_ADR);	// ACR̈̃AhXݒ
	switch(level){
		case 4:
			dat = ICON_BATCASE|ICON_BAT1|ICON_BAT2|ICON_BAT3;
			break;
		case 3:
			dat = ICON_BATCASE|ICON_BAT1|ICON_BAT2;
			break;
		case 2:
			dat = ICON_BATCASE|ICON_BAT1;
			break;
		case 1:
			dat = ICON_BATCASE;
			break;
		case 0:
			dat = 0;
			break;
	}


	I2C_lcd_data(dat);
	I2C_lcd_cmd(0b00111000);	//
}	


/*----------------------------------------------------------------------*
 	Tv F LCDRgXg̐ݒ
 		   F short contrast@0()`63(Z)
 		  l F void
 *----------------------------------------------------------------------*/
void LCD_Contrast( short contrast ) 
{
	I2C_lcd_cmd(0b00111001);	// R}h
	I2C_lcd_cmd(0b01110000 | (contrast & 0xF)); // ʃrbg
	
	I2C_lcd_cmd(0b01011100 | ((contrast >> 4) & 0x3)); // contast High/icon/power
	I2C_lcd_cmd(0b00111000);	//

}

